Skip to main content

List all the versions of a materialized table

GET 

/sql/v1/organizations/:organization_id/environments/:environment_id/databases/:kafka_cluster_id/materialized-tables/:table_name/versions

General Availability

Retrieve a sorted and paginated list of all versions for a specific Materialized Table.

Request

Responses

A list of Materialized Table Versions.

Response Headers
    X-Request-Id

    The unique identifier for the API request.

OpenAPI definition (YAML)
paths:
  ? /sql/v1/organizations/{organization_id}/environments/{environment_id}/databases/{kafka_cluster_id}/materialized-tables/{table_name}/versions
  : get:
      x-lifecycle-stage: General Availability
      x-self-access: true
      x-request-access-name: SQL API v1
      operationId: listSqlv1MaterializedTableVersions
      description: '[![General Availability](https://img.shields.io/badge/Lifecycle%20Stage-General%20Availability-%2345c6e8)](#section/Versioning/API-Lifecycle-Policy)


        Retrieve a sorted and paginated list of all versions for a specific Materialized Table.

        '
      parameters:
      - in: path
        name: organization_id
        required: true
        schema:
          type: string
          format: uuid
        description: The unique identifier for the organization.
      - in: path
        name: environment_id
        required: true
        schema:
          type: string
        description: The unique identifier for the environment.
      - in: path
        name: kafka_cluster_id
        required: true
        schema:
          type: string
        description: The unique identifier for the database.
      - in: path
        name: table_name
        required: true
        schema:
          type: string
        description: The unique identifier for the Materialized Table.
      - name: page_size
        in: query
        required: false
        schema:
          type: integer
          format: int32
          default: 10
          maximum: 100
        description: A pagination size for collection requests.
      - name: page_token
        in: query
        required: false
        schema:
          type: string
          maxLength: 255
        description: An opaque pagination token for collection requests.
      tags:
      - Materialized Table Versions (sql/v1)
      security:
      - resource-api-key: []
      - global-api-key: []
      - external-access-token: []
      responses:
        '200':
          description: A list of Materialized Table Versions.
          content:
            application/json:
              schema:
                type: object
                description: A list of Materialized Table Version resources.
                required:
                - api_version
                - kind
                - metadata
                - data
                properties:
                  api_version:
                    type: string
                    enum:
                    - sql/v1
                    readOnly: true
                  kind:
                    type: string
                    enum:
                    - MaterializedTableVersionList
                    readOnly: true
                  metadata:
                    type: object
                    description: ListMeta describes metadata that resource collections may have
                    properties:
                      first:
                        description: A link to the first page of results. If a response does not contain
                          a first link, then direct navigation to the first page is not supported.
                        type: string
                        format: uri
                        nullable: true
                        example: https://api.confluent.cloud/v2/resourcekinds
                      last:
                        description: A link to the last page of results. If a response does not contain
                          a last link, then direct navigation to the last page is not supported.
                        type: string
                        format: uri
                        nullable: true
                        example: https://api.confluent.cloud/v2/resourcekinds?page_token=bcAOehAY8F16YD84Z1wT
                      prev:
                        description: A link to the previous page of results. If a response does not contain
                          a prev link, then either there is no previous data or backwards traversal through
                          the result set is not supported.
                        type: string
                        format: uri
                        nullable: true
                        example: https://api.confluent.cloud/v2/resourcekinds?page_token=YIXRY97wWYmwzrax4dld
                      next:
                        description: A link to the next page of results. If a response does not contain
                          a next link, then there is no more data available.
                        type: string
                        format: uri
                        nullable: true
                        example: https://api.confluent.cloud/v2/resourcekinds?page_token=UvmDWOB1iwfAIBPj6EYb
                      total_size:
                        description: Number of records in the full result set. This response may be paginated
                          and have a smaller number of records.
                        type: integer
                        format: int32
                        minimum: 0
                        example: 123
                    title: ListMeta
                  data:
                    type: array
                    description: A data property that contains an array of resource items. Each entry
                      in the array is a separate resource.
                    items:
                      type: object
                      description: Represents a specific version of a Materialized Table resource.
                      required:
                      - api_version
                      - kind
                      - metadata
                      - name
                      - organization_id
                      - environment_id
                      - spec
                      properties:
                        api_version:
                          type: string
                          enum:
                          - sql/v1
                          description: APIVersion defines the schema version of this representation of
                            a resource.
                          example: sql/v1
                          readOnly: true
                        kind:
                          type: string
                          description: Kind defines the object this REST resource represents.
                          enum:
                          - MaterializedTableVersion
                          readOnly: true
                        metadata:
                          allOf:
                          - description: ObjectMeta is metadata that all persisted resources must have,
                              which includes all objects users must create.
                            required:
                            - self
                            properties:
                              self:
                                description: Self is a Uniform Resource Locator (URL) at which an object
                                  can be addressed. This URL encodes the service location, API version,
                                  and other particulars necessary to locate the resource at a point in
                                  time
                                type: string
                                format: uri
                                readOnly: true
                                example: https://api.confluent.cloud/v2/kafka-clusters/lkc-f3a90de
                              resource_name:
                                description: Resource Name is a Uniform Resource Identifier (URI) that
                                  is globally unique across space and time. It is represented as a Confluent
                                  Resource Name
                                type: string
                                format: uri
                                readOnly: true
                                example: crn://confluent.cloud/kafka=lkc-f3a90de
                              created_at:
                                type: string
                                format: date-time
                                example: '2006-01-02T15:04:05-07:00'
                                readOnly: true
                                description: The date and time at which this object was created. It is
                                  represented in RFC3339 format and is in UTC.
                              updated_at:
                                type: string
                                format: date-time
                                example: '2006-01-02T15:04:05-07:00'
                                readOnly: true
                                description: The date and time at which this object was last updated.
                                  It is represented in RFC3339 format and is in UTC.
                              deleted_at:
                                type: string
                                format: date-time
                                example: '2006-01-02T15:04:05-07:00'
                                readOnly: true
                                description: The date and time at which this object was (or will be) deleted.
                                  It is represented in RFC3339 format and is in UTC.
                            readOnly: true
                            title: ObjectMeta
                          - type: object
                            properties:
                              self:
                                example: https://flink.us-west1.aws.confluent.cloud/sql/v1/organizations/org-123/environments/env-123/databases/lkc-123/materialized-tables/high-value-orders/versions/4
                        name:
                          type: string
                          description: 'The resource version name, unique within the Kafka cluster.

                            Name conforms to DNS Subdomain (RFC 1123).

                            '
                          pattern: '[a-z0-9]([-a-z0-9]*[a-z0-9])?(\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*'
                          maxLength: 100
                          example: mt-123-v4
                          readOnly: true
                        organization_id:
                          type: string
                          format: uuid
                          description: The unique identifier for the organization.
                          x-immutable: true
                          readOnly: true
                        environment_id:
                          type: string
                          description: The unique identifier for the environment.
                          x-immutable: true
                          readOnly: true
                        spec:
                          type: object
                          description: The specifications of the Materialized Table Version.
                          required:
                          - version
                          - statement
                          properties:
                            version:
                              type: integer
                              format: int32
                              minimum: 1
                              description: The version number of the Materialized Table.
                              example: 4
                              readOnly: true
                            statement:
                              type: string
                              description: 'The full SQL statement for the materialized table as generated
                                by SHOW CREATE MATERIALIZED TABLE at the time of the evolution.

                                '
                              example: CREATE OR ALTER MATERIALIZED TABLE orders AS SELECT user_id, product_id,
                                price FROM orders;
                              readOnly: true
                              maxLength: 131072
                            changes:
                              type: array
                              description: Changes affecting resources since the previous version.
                              items:
                                type: object
                                description: Details of a change to a specific resource.
                                required:
                                - kind
                                - environment_locator
                                - database_locator
                                - name
                                - details
                                properties:
                                  kind:
                                    type: string
                                    description: The type of resource that was changed.
                                    example: MATERIALIZED_TABLE
                                    enum:
                                    - MATERIALIZED_TABLE
                                    - TABLE
                                    - VIEW
                                    - FUNCTION
                                  environment_locator:
                                    type: string
                                    description: The environment containing the resource. Can be either
                                      the environment name or ID, depending on how it is referenced in
                                      the SQL statement text.
                                    example: env-abc
                                  database_locator:
                                    type: string
                                    description: The database containing the resource. Can be either the
                                      database name or ID, depending on how it is referenced in the SQL
                                      statement text.
                                    example: lkc-123
                                  name:
                                    type: string
                                    description: The name of the resource, unique within its scope (environment
                                      and database).
                                    example: orders
                                  details:
                                    type: array
                                    description: Human-readable descriptions of the changes made to this
                                      resource.
                                    items:
                                      type: string
                                    example:
                                    - 'Column ''product_name: VARCHAR'' added'
                                    - 'Column ''product_id: BIGINT'' added'
                                readOnly: true
                                title: sql.v1.ResourceChange
                              readOnly: true
                          title: sql.v1.MaterializedTableVersionSpec
                      title: sql.v1.MaterializedTableVersion
                    uniqueItems: true
                title: sql.v1.MaterializedTableVersionList
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
        '400':
          description: Bad Request
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '400'
                  code: invalid_filter
                  title: Invalid Filter
                  detail: The 'delorean' resource can't be filtered by 'num_doors'
                  source:
                    parameter: num_doors
        '401':
          x-summary: Unauthorized
          description: The request lacks valid authentication credentials for this resource.
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            WWW-Authenticate:
              schema:
                type: string
              description: The unique identifier for the API request.
              example: Basic error="invalid_key", error_description="The API Key is invalid"
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '401'
                  code: user_unauthenticated
                  title: Authentication Required
                  detail: Valid authentication credentials must be provided
        '403':
          x-summary: Forbidden
          description: The access credentials were considered insufficient to grant access
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '403'
                  code: user_unauthorized
                  title: User Access Unauthorized
                  detail: The user 'mcfly' is not allowed to access the 'delorean' resource without the
                    'plutonium' role.
        '404':
          description: Not Found
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '404'
                  title: Not Found
        '429':
          description: Rate Limit Exceeded
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            X-RateLimit-Limit:
              schema:
                type: integer
              description: The maximum number of requests you're permitted to make per time period.
            X-RateLimit-Remaining:
              schema:
                type: integer
              description: The number of requests remaining in the current rate limit window.
            X-RateLimit-Reset:
              schema:
                type: integer
              description: "The relative time in seconds until the current rate-limit window resets. \
                \ \n  \n**Important:** This differs from Github and Twitter's same-named header which\
                \ uses UTC epoch seconds. We use relative time to avoid client/server time synchronization\
                \ issues."
            Retry-After:
              schema:
                type: integer
              description: The number of seconds to wait until the rate limit window resets. Only sent
                when the rate limit is reached.
        '500':
          description: Oops, something went wrong!
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '500'
                  code: out_of_gas
                  title: DeLorean Out Of Gas
                  detail: The DeLorean has run out of gas, but Doc Brown will fill 'er up for you asap
      servers:
      - url: https://flink.region.provider.confluent.cloud
        description: Flink Compute Pool Endpoint